***TFR (Egypt)
*Caroline Krafft
***DHS prenatal annualized data
*v2
*May 13, 2015

*Goal: Annual data for 1991-2011 on governorate-urban/rural prenatal care availability

**************
*1992
*************

use "DHS data/egkr21dt/EGKR21FL.dta", clear

gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2


*Urban/rural
tabu v025

*Governorate
tabu sgovern

*Table
table sgovern v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgovern)

rename prenatal prenatal92

save "1992 prenatal.dta", replace



****************
*1995, 1996/7--no gov
****************

****************
*2000
****************

use "DHS data/egkr42dt/EGKR42FL.DTA", clear

gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2

*Urban/rural
tabu v025

*Governorate--of birth
tabu s102g
rename s102g sgovern

*Table
table sgovern v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgovern)

drop if sgovern==0 | sgovern==99

rename prenatal prenatal00

save "2000 prenatal.dta", replace


********
*2003
********

use "DHS data/egkr4adt/EGKR4AFL.DTA", clear


gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2

*Urban/rural
tabu v025

*Governorate--of birth
tabu s102g
rename s102g sgovern

*Table
table sgovern v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgovern)

drop if sgovern==.

rename prenatal prenatal03

save "2003 prenatal.dta", replace


********
*2005
********

use "DHS data/egkr51dt/EGKR51FL.dta", clear

gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2

*Urban/rural
tabu v025

*Governorate
tabu sgovern

*Table
table sgovern v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgovern)

rename prenatal prenatal05

save "2005 prenatal.dta", replace


********
*2008
********

use "DHS data/egkr5adt/EGKR5AFL.DTA", clear

gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2

*Urban/rural
tabu v025

*Governorate
tabu sgovern
*Luxor with Qena
replace sgovern=27 if sgovern==29


*Table
table sgovern v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgovern)

rename prenatal prenatal08

save "2008 prenatal.dta", replace


********
*2014
********

use "DHS data/egkr61dt/EGKR61FL.DTA", clear
gen prenatal=0 if m2a!=.
replace prenatal=1 if m2a==1 | m2b==1


*Year of birth
tabu b2

*Urban/rural
tabu v025

*Governorate
tabu sgov
*Luxor with Qena
replace sgov=27 if sgov==29


*Table
table sgov v025 if prenatal!=.

*Data
collapse prenatal [aw=v005], by(v025 sgov)

rename prenatal prenatal14
rename sgov sgovern

save "2014 prenatal.dta", replace

********
*Merge
********

merge 1:1 v025 sgovern using "2008 prenatal.dta"

list if _merge!=3
*Frontier
tabu _merge
drop _merge

merge 1:1 v025 sgovern using "2005 prenatal.dta"

list if _merge!=3
*Frontier
tabu _merge
drop _merge


merge 1:1 v025 sgovern using "2005 prenatal.dta"

list if _merge!=3
*Frontier
tabu _merge
drop _merge


merge 1:1 v025 sgovern using "2003 prenatal.dta"

list if _merge!=3
*Can lose Frontier, using only are current rural wrong gov
tabu _merge
drop if _merge==2
drop _merge


merge 1:1 v025 sgovern using "2000 prenatal.dta"

list if _merge!=3
*Can lose Frontier, using only are current rural wrong gov
tabu _merge
drop if _merge==2
drop _merge



merge 1:1 v025 sgovern using "1992 prenatal.dta"

list if _merge!=3
*Can lose Frontier, using only are current rural wrong gov
tabu _merge
drop _merge

drop if sgovern>29

*Need one observation for each of 1991-2011

expand 21

rename v025 urban
rename sgovern gov

gen year=.

bysort gov urban: replace year=1990+_n

tabu year

*Weight for each year

*Have to start with the start and 'middle' of the series and interpolate there, then use changes to project backward

gen wt14=1 if year==2014
replace wt14=5/6 if year==2013
replace wt14=4/6 if year==2012
replace wt14=3/6 if year==2011
replace wt14=2/6 if year==2010
replace wt14=1/6 if year==2009
replace wt14=0 if wt14==.

gen wt08=1 if year==2008
replace wt08=1/6 if year==2013
replace wt08=2/6 if year==2012
replace wt08=3/6 if year==2011
replace wt08=4/6 if year==2010
replace wt08=5/6 if year==2009
replace wt08=2/3 if year==2007
replace wt08=1/3 if year==2006
replace wt08=0 if wt08==.

gen wt05=1 if year==2005
replace wt05=1/3 if year==2007
replace wt05=2/3 if year==2006
replace wt05=1/2 if year==2004
replace wt05=0 if wt05==.

gen wt03=1 if year==2003
replace wt03=1/2 if year==2004
replace wt03=2/3 if year==2002
replace wt03=1/3 if year==2001
replace wt03=0 if wt03==.

gen wt00=1 if year==2000
replace wt00=1/3 if year==2002
replace wt00=2/3 if year==2001
replace wt00=7/8 if year==1999
replace wt00=6/8 if year==1998
replace wt00=5/8 if year==1997
replace wt00=4/8 if year==1996
replace wt00=3/8 if year==1995
replace wt00=2/8 if year==1994
replace wt00=1/8 if year==1993
replace wt00=0 if wt00==.

gen wt92=1 if year==1992
replace wt92=1/8 if year==1999
replace wt92=2/8 if year==1998
replace wt92=3/8 if year==1997
replace wt92=4/8 if year==1996
replace wt92=5/8 if year==1995
replace wt92=6/8 if year==1994
replace wt92=7/8 if year==1993
replace wt92=0 if wt92==.


*Prenatal in year--connect the dots

gen prenataly=wt14*prenatal14+wt08*prenatal08+wt05*prenatal05+wt03*prenatal03+wt00*prenatal00+wt92*prenatal92

tabu year if prenataly==0

sort gov urban year


gen chg_pre=.
bysort gov urban: replace chg_pre=prenataly[_n]-prenataly[_n-1] if prenataly[_n]!=0 & prenataly[_n-1]!=0

bysort gov urban: replace prenataly=prenataly[_n+1]-chg_pre[_n+2] if prenataly[_n]==0 & year==1991

 sum prenataly

list urban gov prenatal* chg* if prenataly>1

drop if gov==2 & urban==2

keep gov urban year prenataly

save "DHS prenatal ts.dta", replace

*Check in excel 

egen group=group(urban gov), label
reshape wide prenataly , i(group) j(year)

*copy
