***TFR (Egypt)
*Caroline Krafft
*TFR Employment Egypt
*v13
*November 9, 2019


*Creating employment rates by sector, gov of emp., urban/rural and year

**********
*1998
**********

use "elms98_Inddata.dta", clear

merge 1:1 indid using "elms98_wts.dta"

rename urbrur urban

*Keeping 15-64 year olds
*Will use those 25-39 in given year

keep if q0104>=15 & q0104<=64

*Going to use for 1998-1991

expand 8

bysort indid: gen year=1990+_n

tabu year

*Public sector employment in year

*Years are just two digit
gen q3101_y=q3101_1+1900 if q3101_1!=-9
gen q3102_y=q3102_1+1900 if q3102_1!=-9
gen q3103_y=q3103_1+1900 if q3103_1!=-9

*Public
gen public=0
*public if first status is public and in time frame
replace public=1 if q3101_y<=year & q3101_6>=1 & q3101_6<=2
*public if second status is public and in time frame
replace public=1 if q3101_y>year & q3102_y<=year & q3102_6>=1 & q3102_6<=2
*public if third status is public and in time frame
replace public=1 if q3102_y>year & q3103_y<=year & q3103_6>=1 & q3103_6<=2

*Governorate of birth construction
gen q3001a=q3201a
replace q3001a=q3202a if q3202a!=.
replace q3001a=q3203a if q3203a!=.
replace q3001a=q3204a if q3203e>89 & q3204a!=.
replace q3001a=gov if q3001a==.

tabu q3001a

drop if q3001a<1 | q3001a>29

replace q3001a=27 if q3001a==29

drop gov
rename q3001a gov

*residence construction
gen q3001d=q3201c
replace q3001d=q3202c if q3202c!=.
replace q3001d=q3203c if q3203c!=.
replace q3001d=q3204c if q3203e>89 & q3204c!=.
replace q3001d=urban if q3001d==.

drop urban
rename q3001d urban


*Keeping if 25-39 at the year

bysort indid: gen year_age=q0104-8+_n

keep if year_age>=25 & year_age<=39



*check
*table year 

*table year q0101 [pw=expan], c(mean employ)
*table year q0101 [pw=expan], c(mean public)
*table year q0101 [pw=expan], c(mean private_ww)
*table year q0101 [pw=expan], c(mean oth_emp)

rename q0101 sex
keep year sex expan public gov urban 


save "1998 total employ.dta", replace


*******
*2006
*******

use "elmps06v3ewa.dta", clear

drop _merge
drop public

replace expan=.

merge 1:1 indid using "elmps06new_wts.dta", update

tabu _merge
drop _merge

*Keeping 15-64 year olds
*Will use those 25-39 in given year

keep if age>=15 & age<=64

*Going to use for 1999-2006

expand 8

bysort indid: gen year=1998+_n

tabu year

*Public sector employment in year


*Public
gen public=0
*public if first status is public and in time frame
replace public=1 if q8001_y<=year & q8001_5>=1 & q8001_5<=2
*public if second status is public and in time frame
replace public=1 if q8001_y>year & q8002_y<=year & q8002_5>=1 & q8002_5<=2
*public if third status is public and in time frame
replace public=1 if q8002_y>year & q8003_y<=year & q8003_5>=1 & q8003_5<=2

*Keeping if 25-39 at the year
bysort indid: gen year_age=age-8+_n

keep if year_age>=25 & year_age<=39


*Governorate of birth
tabu q3001a

drop if q3001a<1 | q3001a>29

replace q3001a=27 if q3001a==29

drop gov
rename q3001a gov

drop urban
rename q3001d urban

*check
*table year 

*table year sex [pw=expan], c(mean employ)
*table year sex [pw=expan], c(mean public)
*table year sex [pw=expan], c(mean private_ww)
*table year sex [pw=expan], c(mean oth_emp)

keep year sex expan public gov urban

save "2006 total employ.dta", replace

***********
*2012
***********

use "elmps12_indiv CK v1.2 w educ.dta", clear

*Keeping 15-64 year olds
*Will use those 25-39 in given year

keep if age>=15 & age<=64

*Going to use for 2012-2006

expand 6

bysort indid: gen year=2006+_n

tabu year

*Public sector employment in year

*Public
gen public=0
*public if first status is public and in time frame
replace public=1 if q6101y<=year & q6102y>year & q6101_05>=1 & q6101_05<=2
*public if second status is public and in time frame
replace public=1 if q6102y<=year & q6103y>year & q6102_05>=1 & q6102_05<=2
*public if third status is public and in time frame
replace public=1 if q6103y<=year & q6104y>year & q6103_05>=1 & q6103_05<=2
*public if fourth status is public and in time frame
replace public=1 if q6104y<=year & q6104_17==5 & q6104_05>=1 & q6104_05<=2


*Keeping if 25-39 at the year

bysort indid: gen year_age=age-6+_n

keep if year_age>=25 & year_age<=39


*Governorate of birth
tabu q3101_1

drop if q3101_1 <1 | q3101_1>29

replace q3101_1 =27 if q3101_1 ==29

drop gov
rename q3101_1 gov


*check
*table year 

*table year sex [pw=expan], c(mean employ)
*table year sex [pw=expan], c(mean public)
*table year sex [pw=expan], c(mean private_ww)
*table year sex [pw=expan], c(mean oth_emp)

rename expan_12 expan
keep year sex expan public gov indid urban

save "2012 total employ.dta", replace


***Creating a full time series on the governorate level

use "2012 total employ.dta", clear

append using "2006 total employ.dta"

append using "1998 total employ.dta"

tabu year

tabu urban, miss
tabu gov, miss

*table year if sex==1 [pw=expan], c(mean employ mean public mean private_ww mean oth_emp)
*table year if sex==2 [pw=expan], c(mean employ mean public mean private_ww mean oth_emp)
*table year [pw=expan], c(mean employ mean public mean private_ww mean oth_emp)

*Female employment

gen Fpublic=0
replace Fpublic=1 if public==1 & sex==2

*Male employment

gen Mpublic=0
replace Mpublic=1 if public==1 & sex==1

collapse public Fpublic Mpublic [pw=expan], by(gov year urban)

sort gov urban year

*One year lag

sort gov urban year

bysort gov urban: gen l1public=public[_n-1]

*Two year lag
sort gov urban year

bysort gov urban: gen l2public=public[_n-2]


save "Egypt employ ts.dta", replace

*****************************************************
****Appendix Figure 10: Graphing public sector trends
*****************************************************

*Cairo, Alex., Giza (urban), Beni-Suef (urban), Kafr El-Sheikh (rural), 
*Fayoum (rural), Sharkia (rural), Damietta (rural)

drop Fpublic Mpublic l1public l2public

keep if (gov==1 & urban==1) | (gov==2 & urban==1) | (gov==21 & urban==1) ///
| (gov==22 & urban==1) | (gov==15 & urban==2) | (gov==23 & urban==2) ///
| (gov==13 & urban==2) | (gov==11 & urban==2) 

egen group=group(gov urban), label 

reshape wide public, i(group) j(year)

drop urban gov

export excel using "Employment examples.xls", replace firstrow(variables)

*******************************************************
***Creating a full time series on the person level
*******************************************************

use "elmps12_indiv CK v1.2 w educ.dta", clear

*Ever public
gen ever_pub=0
replace ever_pub=1 if ussectrp==1 | ussectrp==2 | job1_05==1 | job1_05==2 ///
| job2_05==1 | job2_05==2 | job3_05==1 | job3_05==2 | job4_05==1 | job4_05==2

*How many married women are in place of birth?

gen locmatch=0
replace locmatch=1 if q3101_1==gov & q3101_4==urban

tabu locmatch if sex==2 & marital>=4 [aw=expan]

keep indid q61* q7210y_1 q3101_1 q3101_4 ever_pub

*Governorate of birth
tabu q3101_1

drop if q3101_1 <1 | q3101_1>29

replace q3101_1 =27 if q3101_1 ==29

rename q3101_1 gov
rename q3101_4 urban

*Going to use for 1991-2012

expand 22

bysort indid: gen year=1990+_n

tabu year

*Public sector employment in year

*Public
gen public=0
*public if first status is public and in time frame
replace public=1 if q6101y<=year & q6102y>year & q6101_05>=1 & q6101_05<=2
*public if second status is public and in time frame
replace public=1 if q6102y<=year & q6103y>year & q6102_05>=1 & q6102_05<=2
*public if third status is public and in time frame
replace public=1 if q6103y<=year & q6104y>year & q6103_05>=1 & q6103_05<=2
*public if fourth status is public and in time frame
replace public=1 if q6104y<=year & q6104_17==5 & q6104_05>=1 & q6104_05<=2

rename public i_public

merge m:1 gov urban year using "Egypt employ ts.dta"

tabu _merge
drop if _merge!=3

drop _merge

duplicates report indid year

*One year lag

sort indid year

bysort indid: gen l1_public=i_public[_n-1]

*Two year lag
sort indid year

bysort indid: gen l2_public=i_public[_n-2]


drop q6*

keep if year<2012

*Merging in DHS data

merge m:1 gov urban year using "DHS prenatal ts.dta"

tabu _merge
drop if _merge!=3
drop _merge

*Merging in HDR data

merge m:1 gov year using "HDR life.dta"

tabu _merge
drop _merge

merge m:1 gov year using "HDR lit.dta"

tabu _merge
drop _merge


merge m:1 gov year using "HDR GDP PC.dta"

tabu _merge
drop _merge


rename gov bgov
rename urban burban


save "Egypt employ indiv ts.dta", replace



*******************
*Create spouse ts
*******************

use "Egypt employ indiv ts.dta", clear

merge m:1 indid using "elmps12_indiv CK v1.2 w educ.dta"

tabu age if _merge==2

rename i_public sp_i_public
rename educ2 sp_educ2

gen year_age=year-brthyr+1

tabu year_age if _merge==3
*Small n improbable

*Age groups for age in year

gen yr_agroup=.
replace yr_agroup=1 if year_age>=0 & year_age<=19
replace yr_agroup=2 if year_age>=20 & year_age<=24
replace yr_agroup=3 if year_age>=25 & year_age<=29
replace yr_agroup=4 if year_age>=30 & year_age<=34
replace yr_agroup=5 if year_age>=35 & year_age<=39
replace yr_agroup=6 if year_age>=40 & year_age<=44
replace yr_agroup=7 if year_age>=45 & year_age<.

la def Lyr_agroup 1 "<20" 2 "20-24" 3 "25-29" 4 "30-34" 5 "35-39" ///
6 "40-44" 7 "45+"

la val yr_agroup Lyr_agroup

tabu yr_agroup, miss

rename yr_agroup sp_yr_agroup

keep hhid pn sp_* year

rename pn spcode

save "Egypt employ indiv spouse ts.dta", replace



