***TFR (Egypt)
*Caroline Krafft
***HDR annualized data
*v1
*April 13, 2015

*Goal: Annual data for 1991-2011 on governorate (no u/r) life exp, literacy, pc gdp

*Excel data entered from HDRs

****************
*Life expectancy
****************

import excel "TFR HDR Egypt data for import.xlsx", sheet("Life expectancy") firstrow clear

rename A gov
rename B y1991
rename C y1992
rename D y1998
rename E y2001
rename F y2002
rename G y2004
rename H y2006
rename I y2007


expand 21

gen year=.

bysort gov: replace year=1990+_n

tabu year

*Weight for each year

*Have to start with the 'middle' of the series and interpolate there, then use changes to project forward and backward

gen wt07=1 if year==2007
replace wt07=0 if year!=2007

gen wt06=1 if year==2006
replace wt06=1/2 if year==2005
replace wt06=0 if wt06==.

gen wt04=1 if year==2004
replace wt04=1/2 if year==2005
replace wt04=1/2 if year==2003
replace wt04=0 if wt04==.

gen wt02=1 if year==2002
replace wt02=1/2 if year==2003
replace wt02=0 if wt02==.

gen wt01=1 if year==2001
replace wt01=2/3 if year==2000
replace wt01=1/3 if year==1999
replace wt01=0 if wt01==.

gen wt98=1 if year==1998
replace wt98=1/3 if year==2000
replace wt98=2/3 if year==1999
replace wt98= 5/6 if year==1997
replace wt98= 4/6 if year==1996
replace wt98= 3/6 if year==1995
replace wt98= 2/6 if year==1994
replace wt98= 1/6 if year==1993
replace wt98=0 if wt98==.

gen wt92=1 if year==1992
replace wt92=1/6 if year==1997
replace wt92=2/6 if year==1996
replace wt92=3/6 if year==1995
replace wt92=4/6 if year==1994
replace wt92=5/6 if year==1993
replace wt92=0 if wt92==.

gen wt91=1 if year==1991
replace wt91=0 if wt91==.

gen life=wt07*y2007+wt06*y2006+wt04*y2004+wt02*y2002+wt01*y2001+wt98*y1998+wt92*y1992+wt91*y1991

sort gov year

gen chg=.
bysort gov: replace chg=life[_n]-life[_n-1] if life[_n]!=0 & life[_n-1]!=0

bysort gov: replace life=life[_n-1]+chg[_n-1] if life[_n]==0 & year==2008
bysort gov: replace life=life[_n-1]+chg[_n-2] if life[_n]==0 & year==2009
bysort gov: replace life=life[_n-1]+chg[_n-3] if life[_n]==0 & year==2010
bysort gov: replace life=life[_n-1]+chg[_n-4] if life[_n]==0 & year==2011

keep year gov life

save "HDR life.dta", replace

****************
*Literacy
****************

import excel "TFR HDR Egypt data for import.xlsx", sheet("Literacy") firstrow clear

rename A gov
rename B y1992
rename C y1998
rename D y2001
rename E y2002
rename F y2004
rename G y2006
rename H y2007


expand 21

gen year=.

bysort gov: replace year=1990+_n

tabu year

*Weight for each year

*Have to start with the 'middle' of the series and interpolate there, then use changes to project forward and backward

gen wt07=1 if year==2007
replace wt07=0 if year!=2007

gen wt06=1 if year==2006
replace wt06=1/2 if year==2005
replace wt06=0 if wt06==.

gen wt04=1 if year==2004
replace wt04=1/2 if year==2005
replace wt04=1/2 if year==2003
replace wt04=0 if wt04==.

gen wt02=1 if year==2002
replace wt02=1/2 if year==2003
replace wt02=0 if wt02==.

gen wt01=1 if year==2001
replace wt01=2/3 if year==2000
replace wt01=1/3 if year==1999
replace wt01=0 if wt01==.

gen wt98=1 if year==1998
replace wt98=1/4 if year==2001
replace wt98=2/4 if year==2000
replace wt98=3/4 if year==1999
replace wt98= 5/6 if year==1997
replace wt98= 4/6 if year==1996
replace wt98= 3/6 if year==1995
replace wt98= 2/6 if year==1994
replace wt98= 1/6 if year==1993
replace wt98=0 if wt98==.

gen wt92=1 if year==1992
replace wt92=1/6 if year==1997
replace wt92=2/6 if year==1996
replace wt92=3/6 if year==1995
replace wt92=4/6 if year==1994
replace wt92=5/6 if year==1993
replace wt92=0 if wt92==.

gen lit=wt07*y2007+wt06*y2006+wt04*y2004+wt02*y2002+wt01*y2001+wt98*y1998+wt92*y1992

sort gov year

gen chg=.
bysort gov: replace chg=lit[_n]-lit[_n-1] if lit[_n]!=0 & lit[_n-1]!=0

bysort gov: replace lit=lit[_n-1]+chg[_n-1] if lit[_n]==0 & year==2008
bysort gov: replace lit=lit[_n-1]+chg[_n-2] if lit[_n]==0 & year==2009
bysort gov: replace lit=lit[_n-1]+chg[_n-3] if lit[_n]==0 & year==2010
bysort gov: replace lit=lit[_n-1]+chg[_n-4] if lit[_n]==0 & year==2011

bysort gov: replace lit=lit[_n+1]-chg[_n+2] if lit[_n]==0 & year==1991

replace lit=100 if lit>100 & lit!=.

keep year gov lit

save "HDR lit.dta", replace



****************
*GDP PC
****************

import excel "TFR HDR Egypt data for import.xlsx", sheet("GDP pc") firstrow clear

rename A gov
rename B y1992
rename C y1998
rename D y2000
rename E y2001
rename F y2003
rename G y2005
rename H y2007


expand 21

gen year=.

bysort gov: replace year=1990+_n

tabu year


***Translate into real 2012 terms

*CPI from World Bank Databank CPI 10.15.13
*PPP is from PPP_MDG_EXport...

*1992 is LCU

replace y1992=y1992/0.22101819

*1998 is LCU
replace y1998=y1998/0.361252503

*2000 is LCU
replace y2000=y2000/.382371152

*2001 is LCU
replace y2001=y2001/0.391050049

*2003 is LCU

replace y2003=y2003/0.419864194

*2005 is LCU

replace y2005=y2005/0.489934606

*2007 is LCU

replace y2007=y2007/0.576534891

*Weight for each year

*Have to start with the 'middle' of the series and interpolate there, then use changes to project forward and backward

gen wt07=1 if year==2007
replace wt07=1/2 if year==2006
replace wt07=0 if wt07==.

gen wt05=1 if year==2005
replace wt05=1/2 if year==2006
replace wt05=1/2 if year==2004
replace wt05=0 if wt05==.

gen wt03=1 if year==2003
replace wt03=1/2 if year==2004
replace wt03=1/2 if year==2002
replace wt03=0 if wt03==.

gen wt01=1 if year==2001
replace wt01=1/2 if year==2002
replace wt01=0 if wt01==.

gen wt00=1 if year==2000
replace wt00=1/2 if year==1999
replace wt00=0 if wt00==.

gen wt98=1 if year==1998
replace wt98=1/2 if year==1999
replace wt98= 5/6 if year==1997
replace wt98= 4/6 if year==1996
replace wt98= 3/6 if year==1995
replace wt98= 2/6 if year==1994
replace wt98= 1/6 if year==1993
replace wt98=0 if wt98==.

gen wt92=1 if year==1992
replace wt92=1/6 if year==1997
replace wt92=2/6 if year==1996
replace wt92=3/6 if year==1995
replace wt92=4/6 if year==1994
replace wt92=5/6 if year==1993
replace wt92=0 if wt92==.

gen gdppc=wt07*y2007+wt05*y2005+wt03*y2003+wt01*y2001+wt00*y2000+wt98*y1998+wt92*y1992

sort gov year

gen chg=.
bysort gov: replace chg=gdppc[_n]-gdppc[_n-1] if gdppc[_n]!=0 & gdppc[_n-1]!=0

bysort gov: replace gdppc=gdppc[_n-1]+chg[_n-1] if gdppc[_n]==0 & year==2008
bysort gov: replace gdppc=gdppc[_n-1]+chg[_n-2] if gdppc[_n]==0 & year==2009
bysort gov: replace gdppc=gdppc[_n-1]+chg[_n-3] if gdppc[_n]==0 & year==2010
bysort gov: replace gdppc=gdppc[_n-1]+chg[_n-4] if gdppc[_n]==0 & year==2011

bysort gov: replace gdppc=gdppc[_n+1]-chg[_n+2] if gdppc[_n]==0 & year==1991

keep year gov gdppc

save "HDR GDP PC.dta", replace


