***TFR (Egypt)
*Caroline Krafft
***TFR Sims
*v20
*May 26, 2019

capture log close
log using "TFR Sims BS log 5.26.19.log", replace


*******************************************************************************
*******BOOTSTRAP Sims
*******************************************************************************

program drop _all

program define SIMS

keep base c_int_length c_bord treat

expand 3

*1 is q (base) 2 is l (at risk) 3 is d (unconditional)

sort treat c_bord c_int_length
bysort treat c_bord c_int_length: gen piece=_n

replace base=.981 if c_int_length==1 & c_bord==0 & piece==2

replace base=0 if base==.


sort treat c_bord c_int_length

*Rest of zero
foreach num of numlist 3/30 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==0 & treat==0

replace base=r(sum) if c_int_length==1 & c_bord==1 & piece==2 & treat==0

*Rest of one
foreach num of numlist 33/60 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==1 & treat==0

replace base=r(sum) if c_int_length==1 & c_bord==2 & piece==2 & treat==0

*Rest of two
foreach num of numlist 63/90 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==2 & treat==0

replace base=r(sum) if c_int_length==1 & c_bord==3 & piece==2 & treat==0

*Rest of three
foreach num of numlist 93/120 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==3 & treat==0

replace base=r(sum) if c_int_length==1 & c_bord==4 & piece==2 & treat==0


*Rest of four
foreach num of numlist 123/150 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==4 & treat==0

replace base=r(sum) if c_int_length==1 & c_bord==5 & piece==2 & treat==0

*Rest of five
foreach num of numlist 153/180 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}


*Rest of zero
foreach num of numlist 183/210 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==0 & treat==1

replace base=r(sum) if c_int_length==1 & c_bord==1 & piece==2 & treat==1

*Rest of one
foreach num of numlist 213/240 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==1 & treat==1

replace base=r(sum) if c_int_length==1 & c_bord==2 & piece==2 & treat==1

*Rest of two
foreach num of numlist 243/270 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==2 & treat==1

replace base=r(sum) if c_int_length==1 & c_bord==3 & piece==2 & treat==1

*Rest of three
foreach num of numlist 273/300 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n 
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==3 & treat==1

replace base=r(sum) if c_int_length==1 & c_bord==4 & piece==2 & treat==1


*Rest of four
foreach num of numlist 303/330 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}

sum base if piece==3 & c_bord==4 & treat==1

replace base=r(sum) if c_int_length==1 & c_bord==5 & piece==2 & treat==1

*Rest of five
foreach num of numlist 333/360 {
*d
replace base=base[_n-1]*base[_n-2] if piece==3 & `num'==_n
*l
replace base=base[_n-3]-base[_n-2] if piece==2 & `num'==_n
}


keep if piece==3

collapse (sum) base, by(c_bord treat)

sort treat c_bord

replace base=base*2 if c_bord==5

sum base if treat==0

scalar TFR0=r(sum)

sum base if treat==1 

scalar TFR1=r(sum) 

scalar TFRd=TFR0-TFR1

end



*******************
* BS simple public
*******************

use "TFR Models.dta", clear

sort indid year

program define simplepub

preserve

logit next_born b0.i_public ///
i.have_male b1.educ2 /// 
b1.mteducst2 b1.fteducst2 ///
c.life c.lit c.gdppc c.prenataly ///
b1.burban#b1.bgov b0.c_bord b1.c_int_length b0.c_bord#b1.c_int_length ///
b4.yr_agroup##b4.yr_group ///
, or cluster(psu) 

estimates store est5

expand 2

*Public sector
bysort indid bord int_length: replace i_public=0 if _n==1
bysort indid bord int_length: replace i_public=1 if _n==2

gen treat=i_public

estimates restore est5

predict double base, pr

collapse (mean) base, by(c_int_length c_bord treat)

sort treat c_bord c_int_length

SIMS

restore

end 

set seed 923743

 bootstrap s1=TFR0 s2=TFR1 s3=TFRd, ///
reps(200) cluster(psu) idcluster(newpsu) :  simplepub

*scalar list



*******************************************************************************
*Interacted model own emp.
*******************************************************************************

******************
*BS Public sector
******************

use "TFR Models.dta", clear

sort indid year

program define intpub

preserve

logit next_born b0.i_public_ord ///
i.have_male b1.educ2 /// 
b1.mteducst2 b1.fteducst2 ///
c.life c.lit c.gdppc c.prenataly ///
b1.burban#b1.bgov b0.c_bord b1.c_int_length b0.c_bord#b1.c_int_length ///
b4.yr_agroup##b4.yr_group  ///
, or cluster(psu) 

estimates store est6

expand 2

*Public sector
bysort indid bord int_length: replace i_public_ord=0 if _n==1
bysort indid bord int_length: replace i_public_ord=c_bord+1 if _n==2


*Public sector
bysort indid bord int_length: gen treat=_n-1

estimates restore est6

predict double base, pr

collapse (mean) base, by(c_int_length c_bord treat)

sort treat c_bord c_int_length

SIMS

restore

end 

set seed 923743

 bootstrap s1=TFR0 s2=TFR1 s3=TFRd, ///
reps(200) cluster(psu) idcluster(newpsu) :  intpub


*scalar list


*******************************************************************************
*IV model own emp. RI
*******************************************************************************


*****************
*BS Public sector
*****************

use "TFR Models.dta", clear

sort indid year

program define ivintpub

preserve

*First stage probit
probit i_public c.public_100 c.l1public_100 c.l2public_100 b1.educ2 /// 
b1.mteducst2 b1.fteducst2 ///
c.life c.lit c.gdppc c.prenataly ///
b1.burban#b1.bgov b4.yr_agroup b4.yr_agroup#b4.yr_group b1991.year, ///
cluster(psu)


predict prob, pr
*Because of perfect predictors, replacing if missing
replace prob=0 if prob==. & public_100!=. & l1public_100!=. & l2public_100!=.

*First stage LPM
regress i_public prob b1.educ2 /// 
b1.mteducst2 b1.fteducst2 ///
c.life c.lit c.gdppc c.prenataly ///
b1.burban#b1.bgov b4.yr_agroup b4.yr_agroup#b4.yr_group b1991.year, ///
cluster(psu)

predict prob2
gen resid=i_public-prob2

*Second stage: Include residuals and endogenoues regressor 

logit next_born b0.i_public_ord c.resid c.resid#b0.c_bord ///
i.have_male b1.educ2 /// 
b1.mteducst2 b1.fteducst2 ///
c.life c.lit c.gdppc c.prenataly ///
b1.burban#b1.bgov b0.c_bord b1.c_int_length b0.c_bord#b1.c_int_length b4.yr_agroup b4.yr_agroup#b4.yr_group b1991.year ///
, or  cluster(psu) 

estimates store RI

expand 2

*Public sector
bysort indid bord int_length: replace i_public_ord=0 if _n==1
bysort indid bord int_length: replace i_public_ord=c_bord+1 if _n==2

*Public sector
bysort indid bord int_length: gen treat=_n-1

*Residual
replace resid=0

estimates restore RI

predict double base, pr

collapse (mean) base, by(c_int_length c_bord treat)

sort treat c_bord c_int_length

SIMS

restore

end 

set seed 923743

 bootstrap s1=TFR0 s2=TFR1 s3=TFRd, ///
reps(200) cluster(psu) idcluster(newpsu) :  ivintpub

*scalar list


*******************************************************************************
*FE model--own emp interacted
*******************************************************************************


******************
*BS FE own
******************

use "TFR Models.dta", clear

sort indid year

program define xtintpub

preserve

clogit next_born i.i_public_ord ///
i.have_male ///
c.life c.lit c.gdppc c.prenataly ///
b0.c_bord b1.c_int_length b0.c_bord#b1.c_int_length ///
b4.yr_agroup##b4.yr_group ///
,  or    group(indid)

estimates store FE2

expand 2

*Public sector
bysort indid bord int_length: replace i_public_ord=0 if _n==1
bysort indid bord int_length: replace i_public_ord=c_bord+1 if _n==2

*Public sector
bysort indid bord int_length: gen treat=_n-1

replace indid=indid+string(treat)

estimates restore FE2

predict double base_pc1, pc1

egen ind_tot=sum(next_born), by(indid treat)

gen base=base_pc1*ind_tot

collapse (mean) base, by(c_int_length c_bord treat)

sort treat c_bord c_int_length

SIMS

restore

end 

set seed 923743


 bootstrap s1=TFR0 s2=TFR1 s3=TFRd,  ///
reps(200) cluster(psu) idcluster(newpsu) :  xtintpub

*scalar list



******************************************************************************
*FE model--Rate interacted
******************************************************************************


*****************
*BS FE rate
*****************

use "TFR Models.dta", clear

sort indid year

program define xtintpub10

preserve

clogit next_born c.public_100 c.public_100#b0.c_bord ///
i.have_male ///
c.life c.lit c.gdppc c.prenataly ///
b0.c_bord b1.c_int_length b0.c_bord#b1.c_int_length b4.yr_agroup##b4.yr_group ///
, or    group(indid)

estimates store FE4

expand 2

*Public sector
bysort indid bord int_length: replace public_100=0 if _n==1
bysort indid bord int_length: replace public_100=10 if _n==2

*Public sector
bysort indid bord int_length: gen treat=_n-1

replace indid=indid+string(treat)

estimates restore FE4

predict double base_pc1, pc1

egen ind_tot=sum(next_born), by(indid treat)

gen base=base_pc1*ind_tot

collapse (mean) base, by(c_int_length c_bord treat)

sort treat c_bord c_int_length

SIMS

restore

end 

set seed 923743


 bootstrap s1=TFR0 s2=TFR1 s3=TFRd,  ///
reps(200) cluster(psu) idcluster(newpsu) :  xtintpub10


*scalar list


log close
